// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// WorkspaceVCSProviderLink is an autogenerated mock type for the WorkspaceVCSProviderLink type
type WorkspaceVCSProviderLink struct {
	mock.Mock
}

// CreateLink provides a mock function with given fields: ctx, input
func (_m *WorkspaceVCSProviderLink) CreateLink(ctx context.Context, input *types.CreateWorkspaceVCSProviderLinkInput) (*types.CreateWorkspaceVCSProviderLinkResponse, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.CreateWorkspaceVCSProviderLinkResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateWorkspaceVCSProviderLinkInput) (*types.CreateWorkspaceVCSProviderLinkResponse, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateWorkspaceVCSProviderLinkInput) *types.CreateWorkspaceVCSProviderLinkResponse); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.CreateWorkspaceVCSProviderLinkResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateWorkspaceVCSProviderLinkInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteLink provides a mock function with given fields: ctx, input
func (_m *WorkspaceVCSProviderLink) DeleteLink(ctx context.Context, input *types.DeleteWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.WorkspaceVCSProviderLink
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteWorkspaceVCSProviderLinkInput) *types.WorkspaceVCSProviderLink); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.WorkspaceVCSProviderLink)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.DeleteWorkspaceVCSProviderLinkInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetLink provides a mock function with given fields: ctx, input
func (_m *WorkspaceVCSProviderLink) GetLink(ctx context.Context, input *types.GetWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.WorkspaceVCSProviderLink
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetWorkspaceVCSProviderLinkInput) *types.WorkspaceVCSProviderLink); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.WorkspaceVCSProviderLink)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetWorkspaceVCSProviderLinkInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateLink provides a mock function with given fields: ctx, input
func (_m *WorkspaceVCSProviderLink) UpdateLink(ctx context.Context, input *types.UpdateWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.WorkspaceVCSProviderLink
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateWorkspaceVCSProviderLinkInput) (*types.WorkspaceVCSProviderLink, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateWorkspaceVCSProviderLinkInput) *types.WorkspaceVCSProviderLink); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.WorkspaceVCSProviderLink)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateWorkspaceVCSProviderLinkInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewWorkspaceVCSProviderLink interface {
	mock.TestingT
	Cleanup(func())
}

// NewWorkspaceVCSProviderLink creates a new instance of WorkspaceVCSProviderLink. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewWorkspaceVCSProviderLink(t mockConstructorTestingTNewWorkspaceVCSProviderLink) *WorkspaceVCSProviderLink {
	mock := &WorkspaceVCSProviderLink{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
